﻿using System;
using System.Collections.Concurrent;
using System.Collections.Generic;
using System.Diagnostics;
using System.Threading;

namespace ConcurrentBagCollection
{
    class Program
    {
        static void Main(string[] args)
        {
            ConcurrentBag<int> bag = new ConcurrentBag<int>();
            List<Thread> threads = new List<Thread>();
            Stopwatch sw = new Stopwatch();
            sw.Start();
            Random rand = new Random();
            for (int i = 0; i < 100; i++)
            {
                var thread = new Thread(() =>
                {
                    for (int l = 0; l < 100000; l++)
                        bag.Add(rand.Next());
                });
                threads.Add(thread);
                thread.Start();
            }
            foreach (var th in threads)
            {
                th.Join();
            }
            sw.Stop();
            Console.WriteLine($"The number of items in the concurrent bag: {bag.Count}");
            Console.WriteLine($"Elapsed {sw.ElapsedMilliseconds} ms");
            Console.ReadLine();
        }
    }
}
