﻿using System;
using System.Collections.Concurrent;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;

namespace ProducerConsumerQ1
{
    class Program
    {
        static void Main(string[] args)
        {
            var cq = new Queue<int>();
            List<Thread> consumers = new List<Thread>();
            
            //the producer puts 100 elements into the collection at random intervals of up to 500ms
            var producer = new Thread(() =>
            {
                Random rand = new Random(Thread.CurrentThread.ManagedThreadId);
                for (int l = 0; l < 100; l++)
                {
                    cq.Enqueue(l);
                    Console.WriteLine($"Put  {l}");
                    Thread.Sleep(rand.Next(500));
                }

            });
            producer.Start();
            //  Thread.Sleep(5000); 
            //Consumers receive data from the collection at intervals of up to 5000 ms
            for (int i = 0; i < 10; i++)
            {
                var consumer = new Thread(() =>
                {
                    Random rand = new Random(Thread.CurrentThread.ManagedThreadId);
                    for (int l = 0; l < 10; l++)
                    {
                        try
                        {
                            int result2 = cq.Dequeue();
                            Console.WriteLine($"Take {result2} ");
                        }
                        catch (Exception ex)
                        {
                            Console.WriteLine("Exception during taking: {0}", ex.Message);
                        }

                        Thread.Sleep(rand.Next(5000));
                    }
                });
                consumers.Add(consumer);
                consumer.Start();
            }
            foreach (var th in consumers)
            {
                th.Join();
            }
            producer.Join();
            Console.WriteLine("That's all. Press Enter to finish"); 
            Console.ReadLine();
        }
    }
}
